/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Mon Sep  4 00:05:22 2006 by Jeff Dalton
 * Copyright: (c) 2006, AIAI, University of Edinburgh
 */

package ix.ip2;

import java.awt.Component;

import java.util.*;

import ix.icore.process.event.ProcessStatusEvent;

/**
 * An implementation of StateViewer that does nothing.
 */
class NullStateViewer implements StateViewer {

    /* Methods from the StateViewer interface */

    public Component getView(PanelFrame panelFrame) {
        throw new UnsupportedOperationException("getView");
    }

    public void reset() {
    }

    /* ProcessStatusListener methods */

    public void statusUpdate(ProcessStatusEvent event) { }

    public void newBindings(ProcessStatusEvent event, Map bindings) { }

    public void stateChange(ProcessStatusEvent event, Map delta) { }

    public void stateDeletion(ProcessStatusEvent event, Map delta) { }

    /* End of ProcessStatusListener methods */

}
